/* Small program to allocate and actually use lots of memory, then hog it
 * until killed by a signal. */

/* With 32-bit ints, each block is 4 MB in size */
#define BLOCKS 8

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>

int main() {
	size_t memory = 1024*1024*sizeof(int);
	void * ptr;
	long i, j;

	for (i = 1; i <= BLOCKS; i++) {
		if (ptr = malloc(memory)) {
			printf("Succeeded in allocating %ld MB of RAM\n", i*sizeof(int));
			for (j = 0; j < 1024*1024; j++)
				((int *)ptr)[j] = 1;
		}
		else {
			printf("Failed in allocating %ld MB of RAM\n", i*sizeof(int));
			break;
		}
	}

	/* Sleep forever to hog the memory in use */
	while(1)
		sleep(10);
	
	return 0;
}
