/* Count the number of newlines in a file
 * Uses malloc() and read() to read the file into memory */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

int main(int argc, char * argv[]) {
	int fd;
	struct stat * filestat;
	off_t filesize;
	char * buf;
	char * temp;
	unsigned long lines = 0;

	if (argc < 2) {
		printf("Usage: %s filename\n", argv[0]);
		return 0;
	}

	if ((fd = open(argv[1], O_RDONLY)) == -1) {
		perror(argv[0]);
		return 1;
	}

	if (!(filestat = malloc(sizeof(struct stat)))) {
		fprintf(stderr, "%s: unable to allocate struct stat\n", argv[0]);
		return 1;
	}
	if (fstat(fd, filestat) == -1) {
		perror(argv[0]);
		return 1;
	}
	filesize = filestat->st_size;

	if (!(buf = malloc(filesize+1))) {
		fprintf(stderr, "%s: unable to allocate buffer\n", argv[0]);
		return 2;
	}

	if (read(fd, buf, filesize) == -1) {
		perror(argv[0]);
		return 3;
	}
	if (close(fd) == -1) {
		perror(argv[0]);
	}

	temp = buf;
	while ((temp = strchr(temp, '\n'))) {
		++lines;
		++temp;
	}

	printf("%lu %s\n", lines, argv[1]);

	return 0;
}
